unit hiKAREdit;

interface

uses Kol,Share,Win,Windows;

type
  THIKAREdit = class(THIWin)
   private
    FOld:string;
    texttype:integer;

    procedure _OnChange(Obj:PObj);
    procedure _OnKeyDown( Sender: PControl; var Key: Longint; Shift: DWORD );
   public
    _prop_DataType:procedure of object;
    _prop_Password:boolean;
    _prop_Text:string;
    _prop_IgnoreFirstEvent:integer;
    _data_Str:THI_Event;
    _event_onEnter:THI_Event;
    _event_onChange:THI_Event;

    constructor Create(Parent:PControl);
    procedure Init; override;

    procedure Text;
    procedure Number;

    procedure _work_doText(var _Data:TData; Index:word);
    procedure _work_doText2(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doSelectLength(var _Data:TData; Index:word);
    procedure _work_doSelectText(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);
  end;

implementation

constructor THIKAREdit.Create;
begin
   inherited Create(Parent);
   //Control := NewEditbox(Parent,[]);
   FOld := '0';
end;

procedure THIKAREdit.Init;
var fl:TEditOptions;
begin
   texttype:=0;
   if _prop_IgnoreFirstEvent=0 then texttype:=1;

   if _prop_Password then
      fl := [eoPassword]
   else fl := [];

   Control := NewEditbox(FParent,fl);
   Control.Text := _prop_Text;

   if _prop_Ctl3D = 0 then
    with Control^ do Style := Style and not WS_BORDER;
   inherited;
   Control.OnChange := _OnChange;
   Control.OnKeyDown := _OnKeyDown;
end;

procedure THIKAREdit._work_doText;
begin
   texttype:=1;
   Control.Text := ReadString(_Data,_data_Str,'');
end;

procedure THIKAREdit._work_doText2;
begin
   texttype:=2;
   Control.Text := ReadString(_Data,_data_Str,'');
end;

procedure THIKAREdit._work_doPosition;
begin
   Control.SelStart := ToInteger(_Data);
end;

procedure THIKAREdit._work_doSelectText;
begin
   Control.Selection := ToString(_Data);
end;

procedure THIKAREdit._work_doSelectLength;
begin
   Control.SelLength := ToInteger(_Data);
end;

procedure THIKAREdit._var_Text;
begin
   _Data.data_type := data_str;
   _Data.sdata := Control.Text;
end;

function isNumeric(const s:string):boolean;
var i:word;
begin
  Result := false;

  if s <> '' then
   begin
    for i := 1 to Length(s) do
     if (s[i] < '0')or(s[i] > '9')then
      Exit;
    Result := true;
   end;
end;

procedure THIKAREdit.Number;
var s:string; st:word;
begin
    s := Control.Text;
    st := control.SelStart;
    if isNumeric(s) then
     begin
      _hi_OnEvent(_event_onChange,s);
      FOld := s;
      Exit;
     end
    else if s = '' then
     begin
       FOld := '0';
       Control.Text := '0';
       //Control.SelStart := 0;
       Control.SelectAll;
       Exit;
     end;
    Control.Text := FOld;
    Control.SelStart := St-1;
end;

procedure THIKAREdit.Text;
begin
   if (texttype=1) then _hi_OnEvent(_event_onChange,Control.Text);
   texttype:=1;
end;

procedure THIKAREdit._OnChange;
begin
    _prop_DataType;
end;

procedure THIKAREdit._OnKeyDown;
var s:string;
begin
  if Assigned(_event_onEnter.Event) and( Key = 13) then
   begin
      s := Control.Text;
//      Control.Text := '';
      _hi_OnEvent(_event_onEnter,s);
      Key := 0;
   end;
end;

end.
