//************************************************************************************
//*           -61  HiAsm.               *
//*                                                                                  *
//*                :  . (rubcov@mail.ru)                        *
//*                                                                                  *
//*                                        * 19.01.2005 *  ( .)   *
//*                                                                                  *
//************************************************************************************


unit hiKAR61;

interface

uses Kol,Share,Debug;
const
     Kol_reg = 1200;  {   .}
     Kol_kod = 12000; {   .}

type
  THIKAR61 = class(TDebug)
   private
     FItem:TData;

     CK : word;
     X,Y,Z,T,Bx : real; {  .}

     N_MAX_Register : word; {   .}

   public
    _prop_CK  :integer;
    _prop_X   :real;
    _prop_Y   :real;
    _prop_Z   :real;
    _prop_T   :real;
    _prop_Bx  :real;
    _prop_in  :real;
    _prop_AngleMode: integer;


    _data_CK  :THI_Event;
    _data_X   :THI_Event;
    _data_Y   :THI_Event;
    _data_Z   :THI_Event;
    _data_T   :THI_Event;
    _data_Bx  :THI_Event;
    _data_in  :THI_Event;
    _data_Registers:THI_Event;
    _data_Codes:THI_Event;
    _data_AngleMode:THI_Event;

    _event_onKAR61:THI_Event;
    _event_onKAR61err:THI_Event;
    _event_onKAR61out:THI_Event;

    _prop_Index:TData;
    _data_Index:THI_Event;


    procedure _work_doKAR61(var _Data:TData; Index:word);
    procedure _var_RCK(var _Data:TData; Index:word);
    procedure _var_RX (var _Data:TData; Index:word);
    procedure _var_RY(var _Data:TData; Index:word);
    procedure _var_RZ(var _Data:TData; Index:word);
    procedure _var_RT(var _Data:TData; Index:word);
    procedure _var_RBx(var _Data:TData; Index:word);
    procedure _var_NRegister(var _Data:TData; Index:word);



  end;

implementation

procedure THIKAR61._work_doKAR61;

var 
     kod : array [0..Kol_kod] of word;    {  .}
     reg : array [0..Kol_reg] of real;{  }
     sub : array [0..60] of word; {   .}
     sk  : 0..Kol_kod;            {  .}
     u_sub : byte;                {   .}
     xx  : real; {  .}
     j   : longint;
     ugol: (g, r, grad);
     x_b : word;
     x_b_s : string;
     code : integer;
     flag_jmp : boolean; {      .}



Function Vals(S : string): real; {    .}
var
  code : integer;
     x : real;
begin
    Val(S, x, Code);
    Vals:=x
end;

function UpCaseStrl(S: string): string;
var
  I: Integer;
begin
  for I := 1 to Length(S) do
  if (S[I] >= 'a') and (S[I] <= 'z') then
  Dec(S[I], 32);
  UpCaseStrl := S;
end;

{  x^y.}
Function x_y (x,y : real) : real;
asm
        FLD       Y
        FLD       X
        FYL2X
        FLD1
        FCHS
        FLD       ST(1)
        FRNDINT
        FXCH      ST(2)
        FSUB      ST(0),ST(2)
        FSCALE  
        F2XM1
        FSUBRP    ST(1),ST(0)
        FMUL      ST(0),ST(0)
        FSCALE
        FXCH      ST(1)
        FCOMP
        FWAIT
end;

{  10^x.}
Function x_10 (x : real) : real;
asm
        FLD       X
        FLDL2T
        FMULP     ST(1),ST(0)
        FLD1
        FCHS
        FLD       ST(1)
        FRNDINT
        FXCH      ST(2)
        FSUB      ST(0),ST(2)
        FSCALE  
        F2XM1
        FSUBRP    ST(1),ST(0)
        FMUL      ST(0),ST(0)
        FSCALE
        FXCH      ST(1)
        FCOMP
        FWAIT
end;

function lg (X: real): real;
{ lg(X) := Log2(X) / Log2(10) }
asm
        FLD1
        FLD     X
        FYL2X
        FLDL2T
        FDIV
        FWAIT
end;

function ArcTan2(const Y, X: real): real;
asm
   FLD     Y
   FLD     X
   FPATAN
   FWAIT
end;


var
  i   : word;
  s   : string;
  Arr:PArray;
  Ind:TData;
   dt:TData;
  x_x:real;

procedure Read_Registers;   {     .}
begin
  Ind.Data_type := data_int;
  Ind.idata := 0;
  Arr := ReadArray(_data_Registers);
  if Arr <> nil then
   while Arr._Get(Ind,FItem) do
    begin
     dt.Data_type := data_str;
     dt := FItem;
     x_x:=Vals(dt.sdata);
     If Ind.idata<Kol_reg then reg[Ind.idata]:=x_x else reg[Kol_reg]:=x_x;
     inc(Ind.idata);
   end;
   If Ind.idata<Kol_reg then N_MAX_Register:=Ind.idata else N_MAX_Register:=Kol_reg;
end;   

procedure Read_Codes;            {    .}
var
  flag_jmp : boolean;
  x_b_s    : string;
  x_b      : word;
  code     : integer;
begin
  Ind.Data_type := data_int;
  Ind.idata := 0;
  Arr := ReadArray(_data_Codes);
if Arr <> nil then begin
  i:=0;
  flag_jmp:=False;
  if Arr <> nil then
   while Arr._Get(Ind,FItem) do
    begin
     dt.Data_type := data_str;
     dt := FItem;
     s:=dt.sdata; x_b_s:=s;
           If flag_jmp then x_b_s:=UpCaseStrl(x_b_s)
                       else x_b_s:='$'+UpCaseStrl(x_b_s);
           Val(x_b_s, x_b, code);
           if code <> 0 then x_b:=$54;
           If flag_jmp then flag_jmp:=False
                       else
                           case x_b of
                             $4f,$6f,$7f,$8f,$9f,$af,
                             $bf,$cf,$df,$ef,$51,$53,
                             $57..$5e  : flag_jmp:=True;
                           end;

           If i<Kol_kod then begin
              kod[i]:=x_b;
              inc(i);
           end;
           {writeln ('   ',x_b_s,'   "',x_b,'"');}
     inc(Ind.idata);
   end;
end;
end;   



procedure Write_Registers;            {     .}
var
  N_MAX_R, j : word;
  sj         : string;
begin
//     .
  i:=Kol_reg;
  While (i>0) and (reg[i]=0) do dec(i);
  If i<Kol_reg then N_MAX_Register:=i+1 else N_MAX_Register:=Kol_reg;
  N_MAX_R:=N_MAX_Register;
  Ind.Data_type := data_int;
  Ind.idata := 0;
  Arr := ReadArray(_data_Registers);
if Arr <> nil then begin
  i:=Arr._Count;
  If i<=Kol_reg then begin 
	     If i>N_MAX_R then N_MAX_R:=i;
        end
        else N_MAX_R:=Kol_reg;
  If N_MAX_R<15 then N_MAX_R:=15;
//  .
  For j:=0 to N_MAX_R do begin
      Ind.Data_type := data_int;
      Ind.idata := j;
      Str(reg[j],s); Str(j,sj);
      dt.Data_type := data_str;
      dt.sdata:=s;
      FItem:=dt;
      If j<=i then Arr._Set(Ind,FItem) else Arr._Add(FItem);
  end;
end;
  i:=N_MAX_R
end;   

// ==================     ================

var
   flag_inp : boolean;      {     .}
   flag_end : boolean;      {    .}
   flag_vp  : boolean;      {    "".}
   flag_err : boolean;      {   .}
   s_vvoda  : string;       {   .}
   xs1,xs2  : string;
   code_ugla: integer;
   nps      : byte;
   npss     : string;
   npsx,nspi: integer;

begin
     {  .}
    For i:=0 to Kol_kod do kod[i]:=$50;
    For i:=0 to Kol_reg do reg[i]:=0;
    For i:=0 to 60 do sub[i]:=1; u_sub:=0;
    Bx:=0; X:=0; Y:=0; Z:=0; T:=0;

    {     .}
    code_ugla:= ReadInteger(_Data,_data_AngleMode,_prop_AngleMode);
    case code_ugla of
    0: ugol:=r;
    1: ugol:=g;
    2: ugol:=grad;
    else ugol:=r
    end;
    Bx := ReadReal(_Data,_data_Bx,_prop_Bx);
    T  := ReadReal(_Data,_data_T,_prop_T);
    Z  := ReadReal(_Data,_data_Z,_prop_Z);
    Y  := ReadReal(_Data,_data_Y,_prop_Y);
    X  := ReadReal(_Data,_data_X,_prop_X);
    CK := ReadInteger(_Data,_data_CK,_prop_CK);

    Read_Registers;
    Read_Codes;

    sk:=CK;

//    -61

   flag_inp:=True; flag_vp:=False;
   Flag_end:=False; flag_err:=False; s_vvoda:='';
   Repeat
     Case kod[sk] of
       $00..$09 :  {0...9}
             begin
               if not flag_inp then begin
                  T:=Z; Z:=Y; Y:=X; s_vvoda:=''; nps:=0; npss:='';
               end;
               if flag_vp then begin
                  if x=0 then x:=1;
                  case nps of 
                       0: begin
                          str(x,s_vvoda);
               val(copy(s_vvoda,Pos('E',s_vvoda)+1,Length(s_vvoda)-Pos('E',s_vvoda)),npsx,Code);
                          str(kod[sk],npss);
                          end;
                     1,2: begin
                          str(kod[sk],s_vvoda);
                          npss:=npss+s_vvoda
                          end;
                  end;
                  str(x,s_vvoda); Val(npss, nspi, Code); nspi:=nspi+npsx; str(nspi,xs2);
                  s_vvoda:=copy(s_vvoda,1,Pos('E',s_vvoda))+xs2;
                  Val (s_vvoda, X, Code);
                  inc(nps);
                  If x> 1e300 then x:= 1e300; {  .}
                  If x<-1e300 then x:=-1e300;
                  end
               else begin
                  nps:=0; npss:='';
                  str(kod[sk],xs2); s_vvoda:=s_vvoda+xs2;
                  Val (s_vvoda, X, Code);
               end;
               flag_inp:=True;
               inc(sk)
             end;
       $0a : begin {,}
               if flag_vp then flag_err:=True
               else if flag_inp then s_vvoda:=s_vvoda+'.';
               inc(sk)
             end;
       $0b : begin {/-/}
               if flag_vp then begin
                  If x=0 then x:=1;
                  if nps=0 then begin
                     str(x,xs2);
                     if copy(xs2,pos('E',xs2)+1,1)='-' 
                            then begin 
                                   delete(xs2,pos('E',xs2)+1,1);
                                   insert('+',xs2,pos('E',xs2)+1)
                                 end
                            else begin
                                   delete(xs2,pos('E',xs2)+1,1);
                                   insert('-',xs2,pos('E',xs2)+1)
                                 end;
                     Val (xs2, X, Code);
                  end else begin
                     str(x,s_vvoda); Val(npss, nspi, Code); nspi:=npsx-nspi; str(nspi,xs2);
                     s_vvoda:=copy(s_vvoda,1,Pos('E',s_vvoda))+xs2;
                     Val (s_vvoda, X, Code);
                     If x> 1e300 then x:= 1e300; {  .}
                     If x<-1e300 then x:=-1e300;
                     s_vvoda:=''; nps:=0; npss:='';
                  end
                  end
               else
                  X:=-X;
               inc(sk)
             end;
       $0c : begin {}
               If x=0 then X:=1;
               flag_vp:=True;
               flag_inp:=True;
               s_vvoda:=''; nps:=0; npss:='';
               inc(sk)
             end;
       $0d : begin {Cx}
               X:=0;
               flag_vp:=False;
               s_vvoda:='';
               inc(sk)
             end;
       $0e : begin {B|}
               flag_vp:=False;
               s_vvoda:='';
               T:=Z; Z:=Y; Y:=X;
               inc(sk)
             end;
       $0f : begin {FBx}
               flag_vp:=False;
               flag_inp:=False;
               T:=Z; Z:=Y; Y:=X; X:=Bx;
               inc(sk)
             end;
       $10 : begin {+}
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y+X; Y:=Z; Z:=T;
               inc(sk)
             end;
       $11 : begin {  -   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y-X; Y:=Z; Z:=T;
               inc(sk)
             end;
       $12 : begin {  x   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y*X; Y:=Z; Z:=T;
               inc(sk)
             end;
       $13 : begin {  :   }
               flag_vp:=False;
               flag_inp:=False;
               If x=0 then flag_err:=True else begin Bx:=X; X:=Y/X; Y:=Z; Z:=T; end;
               inc(sk)
             end;
       $14 : begin { <->  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y; Y:=Bx;
               inc(sk)
             end;
       $15 : begin {F10^x }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=x_10(X);
               inc(sk)
             end;
       $16 : begin {Fe^x  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=exp(X);
               inc(sk)
             end;
       $17 : begin { Flg  }
               flag_vp:=False;
               flag_inp:=False;
               if x<=0 then flag_err:=True else begin Bx:=X; X:=lg(X); end;
               inc(sk)
             end;
       $18 : begin { Fln  }
               flag_vp:=False;
               flag_inp:=False;
               if x<=0 then flag_err:=True else begin Bx:=X; X:=ln(X); end;
               inc(sk)
             end;
       $19 : begin {F\sin }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
	       if (x<=1)and(x>=-1) then	
                case ugol of
                  g    : X:=ArcTan2(x,sqrt(1-sqr(x)))/Pi*180;
                  r    : X:=ArcTan2(x,sqrt(1-sqr(x)));
                  grad : X:=ArcTan2(x,sqrt(1-sqr(x)))/Pi*200;
                end else flag_err:=True;
               inc(sk)
             end;
       $1a : begin {F\cos }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
	       if (x<=1)and(x>=-1) then	
                case ugol of
                  g    : X:=ArcTan2(sqrt(1-sqr(x)),x)/Pi*180;
                  r    : X:=ArcTan2(sqrt(1-sqr(x)),x);
                  grad : X:=ArcTan2(sqrt(1-sqr(x)),x)/Pi*200;
                end else flag_err:=True;
               inc(sk)
             end;
       $1b : begin {F\tg  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               case ugol of
                  g    : x:=ArcTan2(x,1)/Pi*180;
                  r    : x:=ArcTan2(x,1);
                  grad : x:=ArcTan2(x,1)/Pi*200;

               end;
               inc(sk)
             end;
       $1c : begin {Fsin  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               case ugol of
                  g    : X:=sin(X/180*Pi);
                  r    : X:=sin(X);
                  grad : X:=sin(X/200*Pi);
               end;
               inc(sk)
             end;
       $1d : begin {Fcos  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               case ugol of
                  g    : X:=cos(X/180*Pi);
                  r    : X:=cos(X);
                  grad : X:=cos(X/200*Pi);
               end;
               inc(sk)
             end;
       $1e : begin {Ftg   }
               flag_vp:=False;
               flag_inp:=False;
               case ugol of
                  g    : xx:=X/180*Pi;
                  r    : xx:=X;
                  grad : xx:=X/200*Pi;
               end;
               if cos(xx)=0 then flag_err:=True else begin
                  Bx:=X; X:=sin(xx)/cos(xx); end;
               inc(sk)
             end;
       $1f : begin {FBx2}
               flag_vp:=False;
               flag_inp:=False;
               X:=Bx;
               inc(sk)
             end;
       $20 : begin {Fpi   }
               flag_vp:=False;
               flag_inp:=False;
               T:=Z; Z:=Y; Y:=X; X:=Pi;
               inc(sk)
             end;
       $21 : begin {FSQR  }
               flag_vp:=False;
               flag_inp:=False;
               if x<0 then flag_err:=True else begin Bx:=X; X:=sqrt(X); end;
               inc(sk)
             end;
       $22 : begin {Fx^2  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=sqr(X);
               inc(sk)
             end;
       $23 : begin {F1/x  }
               flag_vp:=False;
               flag_inp:=False;
               if x=0 then flag_err:=True else begin Bx:=X; X:=1/X; end;
               inc(sk)
             end;
       $24 : begin {Fx^y  }
               flag_vp:=False;
               flag_inp:=False;
               if x<=0 then flag_err:=True else begin Bx:=X; X:=x_y(X,Y); end;
               inc(sk)
             end;
       $25 : begin { F@   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y; Y:=Z; Z:=T; T:=Bx;
               inc(sk)
             end;
       $26,
       $3d : begin {Ko'>  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               xx:=Frac(x)*100; {  .}
               If xx>=60 then flag_err:=True;
               X:=int(x)+xx/60;
               inc(sk)
             end;
       $27 : begin { K-   }
               flag_vp:=False;
               flag_inp:=False;
               flag_err:=True;
               inc(sk,2)
             end;
       $28 : begin { Kx   }
               flag_vp:=False;
               flag_inp:=False;
               flag_err:=True;
               inc(sk,2)
             end;
       $29 : begin { K:   }
               flag_vp:=False;
               flag_inp:=False;
               flag_err:=True;
               inc(sk,2)
             end;
       $2a : begin {Ko'" >}
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               xx:=Frac(x)*100; {  .}
               If xx>=60 then flag_err:=True;
               x :=Frac(xx)*100;{  .}
               If x>=60 then flag_err:=True;
               X:=int(Bx)+int(xx)/60+x/3600;
               inc(sk)
             end;
       $2f : begin {\x\ -    .  }
               flag_vp:=False;
               flag_inp:=False;
               {Bx:=X;}
               if (x>-1E-300) and (x<1E-300) then X:=0 else begin
                  If x<0 then xx:=x_10(INT(Lg(-x))-7) else xx:=x_10(INT(Lg(x))-7);
                  X:=(INT(x/xx)+INT(2*(x/xx-INT(x/xx))))*xx;
                  end;
               inc(sk)
             end;
       $30 : begin {Ko'" <}
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               x :=int(x);        {  }
               xx:=Frac(Bx)*60;   {  .}
               X :=x+int(xx)/100+Frac(xx)*0.006;
               inc(sk)
             end;
       $31 : begin {K|x|  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               If X<0 then X:=-X;
               inc(sk)
             end;
       $32 : begin {K   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               If x<0 then X:=-1
                      else if x>0 then X:=1;
               inc(sk)
             end;
       $33 : begin {Ko'<  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               xx:=int(x);        {  }
               X :=xx+Frac(x)*0.6;
               inc(sk)
             end;
       $34 : begin {K[x]  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=int(X);
               inc(sk)
             end;
       $35 : begin // K{x}  
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Frac(X);
               inc(sk)
             end;
       $36 : begin {Kmax  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               If x<y then X:=Y;
               If (y=0) or (Bx=0) then X:=0; {   -
                                                  -61}
               inc(sk)
             end;
       $37 : begin {  V   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               X :=Round(X) or Round(Y);
               inc(sk)
             end;
       $38 : begin {  ^   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               X := Round(X) and Round(Y);
               inc(sk)
             end;
       $39 : begin { K*   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               X :=Round(X) xor Round(Y);
               inc(sk)
             end;
       $3a : begin {K  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               X := Not Round(X);
               inc(sk)
             end;
       $3b : begin {   }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X;
               X:=Random;
               inc(sk)
             end;
       $3c : begin { in   }
               flag_vp:=False;
               flag_inp:=False;
               X:=ReadReal(_Data,_data_in,_prop_in);
               inc(sk)
             end;
       $3e : begin {y->x  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=Y;
               inc(sk)
             end;
       $3f : begin {(x) -   .  }
               flag_vp:=False;
               flag_inp:=False;
               Bx:=X; X:=INT(x)+INT(2*(x-INT(x)));
               inc(sk)
             end;
       $40..$4e : begin { x-0...x- }
               flag_vp:=False;
               flag_inp:=False;
               reg[kod[sk]-$40]:=X;
               inc(sk)
             end;
       $4f : begin {     0...255 }
               flag_vp:=False;
               flag_inp:=False;
               reg[kod[sk+1]]:=X;
               inc(sk,2)
             end;
       $50 : begin { /  }
               Flag_end:=True;
               inc(sk)
             end;
       $51 : begin {    }
               flag_vp:=False;
               flag_inp:=False;
               sk:=kod[sk+1];
             end;
       $52 : begin { /  }
               flag_vp:=False;
               flag_inp:=False;
               if u_sub>0 then dec(u_sub);
               sk:=sub[u_sub];
             end;
       $53 : begin {    }
               flag_vp:=False;
               flag_inp:=False;
               If sk+2<Kol_kod then begin sub[u_sub]:=sk+2; inc(u_sub) end else flag_err:=True;
               sk:=kod[sk+1];
             end;
       $54..$56 : begin {  }
               flag_vp:=False;
               flag_inp:=False;
               inc(sk)
             end;
       $57 : begin {Fx#0  }
               flag_vp:=False;
               flag_inp:=False;
               inc (sk);
               If x=0 then sk:=kod[sk]
                      else inc (sk);
             end;
       $58 : begin { FL2  }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[2]);
               xx:=xx-1;
               inc (sk);
               if xx>0 then begin
                            sk:=kod[sk];
                            reg[2]:=xx;
                            end
                       else begin
                            inc (sk);
                            reg[2]:=1;
                            end;
             end;
       $59 : begin {Fx>=0 }
               flag_vp:=False;
               flag_inp:=False;
               inc (sk);
               If x<0 then sk:=kod[sk]
                      else inc (sk);
             end;
       $5a : begin { FL3  }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[3]);
               xx:=xx-1;
               inc (sk);
               if xx>0 then begin
                            sk:=kod[sk];
                            reg[3]:=xx;
                            end
                       else begin
                            inc (sk);
                            reg[3]:=1;
                            end;
             end;
       $5b : begin { FL1  }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[1]);
               xx:=xx-1;
               inc (sk);
               if xx>0 then begin
                            sk:=kod[sk];
                            reg[1]:=xx;
                            end
                       else begin
                            inc (sk);
                            reg[1]:=1;
                            end;
             end;
       $5c : begin {Fx<0  }
               flag_vp:=False;
               flag_inp:=False;
               inc (sk);
               If x>=0 then sk:=kod[sk]
                       else inc (sk);
             end;
       $5d : begin { FL0  }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               xx:=xx-1;
               inc (sk);
               if xx>0 then begin
                            sk:=kod[sk];
                            reg[0]:=xx;
                            end
                       else begin
                            inc (sk);
                            reg[0]:=1;
                            end;
             end;
       $5e : begin {Fx=0  }
               flag_vp:=False;
               flag_inp:=False;
               inc (sk);
               If x<>0 then sk:=kod[sk]
                       else inc (sk);
             end;
       $5f : begin { Out }
               _hi_OnEvent(_event_onKAR61out,x);
               inc(sk)
             end;
       $60..$6e : begin { -x0...-x }
               flag_vp:=False;
               flag_inp:=False;
               T:=Z; Z:=Y; Y:=X; X:=reg[kod[sk]-$60];
               inc(sk)
             end;
       $6f : begin {     0...255  }
               flag_vp:=False;
               flag_inp:=False;
               T:=Z; Z:=Y; Y:=X; X:=reg[kod[sk+1]];
               inc(sk,2)
             end;
       $70..$73 : begin { Kx#00...Kx#03 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$70]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$70]:=xx;
               If x=0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $74..$76 : begin { Kx#04...Kx#06 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$70]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$70]:=xx;
               If x=0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $77..$7e : begin { Kx#07...Kx#0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$70]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$70]:=xx;
               If x=0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $7f : begin {  Kx#0   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               If x=0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $80..$83 : begin { K0...K3 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$80]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$80]:=xx;
               sk:=Trunc(xx)
             end;
       $84..$86 : begin { K4...K6 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$80]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$80]:=xx;
               sk:=Trunc(xx)
             end;
       $87..$8e : begin { K7...K }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$80]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$80]:=xx;
               sk:=Trunc(xx)
             end;
       $8f : begin {     R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               sk:=Trunc(xx)
             end;
       $90..$93 : begin { Kx>=00...Kx>=03 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$90]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$90]:=xx;
               If x<0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $94..$96 : begin { Kx>=04...Kx>=06 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$90]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$90]:=xx;
               If x<0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $97..$9e : begin { Kx>=07...Kx>=0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$90]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$90]:=xx;
               If x<0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $9f : begin {  Kx>=0   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               If x<0 then sk:=Trunc(xx)
                      else inc (sk);
             end;
       $a0..$a3 : begin { K0...K3 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$a0]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$a0]:=xx;
               If sk+1<Kol_kod then begin sub[u_sub]:=sk+1; inc(u_sub) end else flag_err:=True;
               sk:=Trunc(xx)
             end;
       $a4..$a6 : begin { K4...K6 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$a0]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$a0]:=xx;
               If sk+1<Kol_kod then begin sub[u_sub]:=sk+1; inc(u_sub) end else flag_err:=True;
               sk:=Trunc(xx)
             end;
       $a7..$ae : begin { K7...K }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$a0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$a0]:=xx;
               If sk+1<Kol_kod then begin sub[u_sub]:=sk+1; inc(u_sub) end else flag_err:=True;
               sk:=Trunc(xx)
             end;
       $af : begin {     R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               If sk+1<Kol_kod then begin sub[u_sub]:=sk+1; inc(u_sub) end else flag_err:=True;
               sk:=Trunc(xx)
             end;
       $b0..$b3 : begin { Kx-0...Kx-3 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$b0]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$b0]:=xx;
               reg[Trunc(xx)]:=X;
               inc(sk)
             end;
       $b4..$b6 : begin { Kx-4...Kx-6 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$b0]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$b0]:=xx;
               reg[Trunc(xx)]:=X;
               inc(sk)
             end;
       $b7..$be : begin { Kx-7...Kx- }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$b0]);
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$b0]:=xx;
               reg[Trunc(xx)]:=X;
               inc(sk)
             end;
       $bf : begin {  Kx-   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[0]:=xx;
               reg[Trunc(xx)]:=X;
               inc(sk)
             end;
       $c0..$c3 : begin { Kx<00...Kx<03 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$c0]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$c0]:=xx;
               If x>=0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $c4..$c6 : begin { Kx<04...Kx<06 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$c0]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$c0]:=xx;
               If x>=0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $c7..$ce : begin { Kx<07...Kx<0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$c0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$c0]:=xx;
               If x>=0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $cf : begin {  Kx<0   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               If x>=0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $d0..$d3 : begin { K-x0...K-x3 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$d0]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$d0]:=xx;
               T:=Z; Z:=Y; Y:=X; X:=reg[Trunc(xx)];
               inc(sk)
             end;
       $d4..$d6 : begin { K-x4...K-x6 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$d0]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$d0]:=xx;
               T:=Z; Z:=Y; Y:=X; X:=reg[Trunc(xx)];
               inc(sk)
             end;
       $d7..$de : begin { K-x0...K-x }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$d0]);
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[kod[sk]-$d0]:=xx;
               T:=Z; Z:=Y; Y:=X; X:=reg[Trunc(xx)];
               inc(sk)
             end;
       $df : begin {  K-x   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_reg) then xx:=Kol_reg;
               reg[0]:=xx;
               T:=Z; Z:=Y; Y:=X; X:=reg[Trunc(xx)];
               inc(sk)
             end;

       $e0..$e3 : begin { Kx=00...Kx=03 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$e0]);
               xx:=xx-1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$e0]:=xx;
               If x<>0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $e4..$e6 : begin { Kx=04...Kx=06 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$e0]);
               xx:=xx+1;
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$e0]:=xx;
               If x<>0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $e7..$ee : begin { Kx=07...Kx=0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[kod[sk]-$e0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[kod[sk]-$e0]:=xx;
               If x<>0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
       $ef : begin {  Kx=0   R0 }
               flag_vp:=False;
               flag_inp:=False;
               xx:=round(reg[0]);
               if (xx<0) or (xx>Kol_kod) then xx:=Kol_kod;
               reg[0]:=xx;
               If x<>0 then sk:=Trunc(xx)
                       else inc (sk);
             end;
      $f0  : begin {    X, .. |x|<1e+300 }
                  If x>1e300 then begin flag_err:=true; x:=1e300 end;
                  If x<-1e300 then begin flag_err:=true; x:=-1e300 end;
                  inc(sk)
                 end;
      $f1..$ff : begin {    X, .. x<1e+300 }
                  If x>=1e+300 then flag_err:=True;
                  inc(sk)
                 end;
     else begin
            {     .}
            Flag_end:=True;
          end;
     end;
     If flag_err then Flag_end:=True;
   Until Flag_end;
// !!!!!!!!!!!!!!   . !!!!!!!!!!!!!!!!!!!!!!!!!!


{    .}
    CK:=sk;
    Write_Registers;
    Write_Registers;
    If flag_err then _hi_OnEvent(_event_onKAR61err,x) else _hi_OnEvent(_event_onKAR61,x);
end;

procedure THIKAR61._var_RCK;
begin
  _Data.data_type := data_int;
  _Data.idata := CK;
end;
procedure THIKAR61._var_RX;
begin
  _Data.data_type := data_real;
  _Data.rdata := X;
end;
procedure THIKAR61._var_RY;
begin
  _Data.data_type := data_real;
  _Data.rdata := Y;
end;
procedure THIKAR61._var_RZ;
begin
  _Data.data_type := data_real;
  _Data.rdata := Z;
end;
procedure THIKAR61._var_RT;
begin
  _Data.data_type := data_real;
  _Data.rdata := T;
end;
procedure THIKAR61._var_RBx;
begin
  _Data.data_type := data_real;
  _Data.rdata := Bx;
end;
procedure THIKAR61._var_NRegister;
begin
  _Data.data_type := data_int;
  _Data.idata := N_MAX_Register;
end;

end.
